﻿Type=StaticCode
Version=3.8
B4A=true
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
	Log(DateTime.Date(DateTime.Now))
	Log(DateTime.Time(DateTime.Now))

	'or with DateUtils library:
	'Log(DateUtils.TicksToString(DateTime.Now))

End Sub
Sub test(FirstTime As Boolean)
	Dim job As HttpJob
	'job.Download(...)
	'job.GetRequest.SetHeader("username", ...)
	'job.GetRequest.SetHeader("password", ...)
'   SetNinePatchButton(Button1, "btn_bg", "btn_bg_pressed")
'   SetNinePatchDrawable(Label3, "label_bg")
End Sub
Sub fnc
   Dim grid(,) As Int = Create2DArray(3, Array As Int(1, 2, 3, 4, 5, 6))
   'grid =   1, 2, 3
   '      4, 5, 6
End Sub

Sub Create2DArray(RowLength As Int, Arr() As Int) As Int(,)
   Dim rows As Int = Arr.Length / RowLength
   Dim td(rows, RowLength) As Int
   For r = 0 To rows - 1
      For c = 0 To RowLength - 1
         td(r, c) = Arr(r * RowLength + c)
      Next
   Next
   Return td
End Sub

Sub SetNinePatchDrawable(Control As View, ImageName As String)
   Dim r As Reflector
   Dim package As String
   Dim id As Int
   package = r.GetStaticField("anywheresoftware.b4a.BA", "packageName")
   id = r.GetStaticField(package & ".R$drawable", ImageName)
   r.Target = r.GetContext
   r.Target = r.RunMethod("getResources")
   Control.Background = r.RunMethod2("getDrawable", id, "java.lang.int")
End Sub

Sub SetNinePatchButton(Btn As Button, DefaultImage As String, PressedImage As String)
   Dim r As Reflector
   Dim package As String
   Dim idDefault, idPressed As Int
   package = r.GetStaticField("anywheresoftware.b4a.BA", "packageName")
   idDefault = r.GetStaticField(package & ".R$drawable", DefaultImage)
   idPressed = r.GetStaticField(package & ".R$drawable", PressedImage)
   r.Target = r.GetContext
   r.Target = r.RunMethod("getResources")
   Dim sd As StateListDrawable
   sd.Initialize
   sd.AddState(sd.State_Pressed, r.RunMethod2("getDrawable", idPressed, "java.lang.int"))
   sd.AddCatchAllState( r.RunMethod2("getDrawable", idDefault, "java.lang.int"))
   Btn.Background = sd
End Sub

Sub Activity_Create(FirstTime As Boolean)
    'Do not forget to load the layout file created with the visual designer. For example:
    'Activity.LoadLayout("Layout1")
    'Activity.LoadLayout("Main")
    Dim LongString As String
    LongString = "This very long line of text needs to be truncated to the width of the label regardless of which font type is used."
    'lbl1.Text = LongString
    'lbl2.Text = TrimWidth(lbl1.Text, lbl1.Typeface, lbl1.TextSize, lbl1.Width-30dip)
    'lbl3.Text = LongString
    'lbl4.Text = TrimWidth(lbl3.Text, lbl3.Typeface, lbl3.TextSize, lbl3.Width-30dip)
End Sub

Sub TrimWidth(Text As String, Style As Typeface, Size As Int, MaxWidth As Int) As String
  Dim c As Canvas
  Dim width As Int
  'c.Initialize(Activity)
  width = c.MeasureStringWidth(Text, Style, Size)
  If width >= MaxWidth Then
	  Do Until width < MaxWidth
      Text = Text.SubString2(0, Text.Length - 1)
   	  width = c.MeasureStringWidth(Text, Style, Size)
   	Loop
   	Return Text
	Else
    Return Text
  End If
End Sub

Sub GetParent(v As View) As View
  Dim r As Reflector
  r.Target = v
  Return r.RunMethod("getParent")
End Sub
Sub GetSDK() As Int
	Dim p As Phone
	Return p.SdkVersion
End Sub
Sub GetSDKversion() As String
	Dim versions As Map
	versions.Initialize
	versions.Put(3,"1.5")
	versions.Put(4,"1.6")
	versions.Put(7,"2.1")
	versions.Put(8,"2.2")
	versions.Put(10,"2.3.3")
	versions.Put(11,"3.0")
	versions.Put(12,"3.1")
	versions.Put(13,"3.2")
	versions.Put(14,"4.0")
	versions.Put(15,"4.0.3")
	versions.Put(16,"4.1.2")
	versions.Put(17,"4.2.2")
	versions.Put(18,"4.3")
	versions.Put(19,"4.4.2")
	Dim p As Phone
	Return versions.Get(p.SdkVersion)
End Sub
